/****************************************************************************
Prolog to Wam Compiler                     INRIA Rocquencourt - ChLoE Project
Version 2.21                                               Daniel Diaz - 1994

File : fd_bips.c
Main : no_main
****************************************************************************/

#define DEBUG_LEVEL    0

#include "wam_engine.h"
#include "fd_engine.h"

#include "fd_bips.h"
#include "fd_bips.usr"


#define ASCII_PRED "fd_vector_max"
#define PRED       X66645F766563746F725F6D6178
#define ARITY      1

Begin_Public_Pred
      pragma_c(Fd_Vector_Max_1)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "fd_infinity"
#define PRED       X66645F696E66696E697479
#define ARITY      1

Begin_Public_Pred
      pragma_c(get_integer(infinity,0))
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "fd_var"
#define PRED       X66645F766172
#define ARITY      1

Begin_Public_Pred
      pragma_c(Fd_Var_1)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "fd_min"
#define PRED       X66645F6D696E
#define ARITY      2

Begin_Public_Pred
      pragma_c(Fd_Min_2)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "fd_max"
#define PRED       X66645F6D6178
#define ARITY      2

Begin_Public_Pred
      pragma_c(Fd_Max_2)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "fd_dom"
#define PRED       X66645F646F6D
#define ARITY      2

Begin_Public_Pred
      pragma_c(Fd_Dom_2)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "fd_size"
#define PRED       X66645F73697A65
#define ARITY      2

Begin_Public_Pred
      pragma_c(Fd_Size_2)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "fd_extra_cstr"
#define PRED       X66645F65787472615F63737472
#define ARITY      2

Begin_Public_Pred
      pragma_c(Fd_Extra_Cstr_2)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "fd_has_vector"
#define PRED       X66645F6861735F766563746F72
#define ARITY      1

Begin_Public_Pred
      pragma_c(Fd_Has_Vector_1)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "fd_use_vector"
#define PRED       X66645F7573655F766563746F72
#define ARITY      1

Begin_Public_Pred
      fd_set_x_AF(1,1)
      fd_x_value_in_A_frame(0)
      fd_install_constraint_with_x_AF(1,1)
      fd_call_constraint
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Fd_Install(1)

      fd_create_C_frame(1,0,1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(1)

      fd_allocate
      fd_integer(1,0)
      fd_integer(0,2)
      fd_interval_range(0,1,0)
      fd_integer(2,4)
      fd_integer(1,infinity)
      fd_interval_range(1,2,1)
      fd_union(0,1)
      fd_integer(2,3)
      fd_integer(1,infinity)
      fd_interval_range(1,2,1)
      fd_union(0,1)
      fd_tell_range(0)
      fd_proceed

End_Fd_Constraint



#define ASCII_PRED "fd_unify"
#define PRED       X66645F756E696679
#define ARITY      2

Begin_Public_Pred
      fd_set_x_AF(2,2)
      fd_x_value_in_A_frame(0)
      fd_x_value_in_A_frame(1)
      fd_install_constraint_with_x_AF(2,2)
      fd_call_constraint
      fd_install_constraint_with_x_AF(3,2)
      fd_call_constraint
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Fd_Install(2)

      fd_create_C_frame(2,0,1)
      fd_install_ind_dom(1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(2)

      fd_allocate
      fd_ind_dom(0,1)
      fd_tell_range(0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(3)

      fd_create_C_frame(3,1,1)
      fd_install_ind_dom(0)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(3)

      fd_allocate
      fd_ind_dom(0,0)
      fd_tell_range(0)
      fd_proceed

End_Fd_Constraint



#define ASCII_PRED "domain"
#define PRED       X646F6D61696E
#define ARITY      3

Begin_Public_Pred
      switch_on_term(G_label(1),G_label(2),fail,G_label(4),fail)

label(1)
      try_me_else(3)

label(2)
      get_nil(0)
      proceed

label(3)
      trust_me_else_fail

label(4)
      get_list(0)
      unify_x_variable(4)
      unify_x_variable(0)
      fd_set_x_AF(3,3)
      fd_x_value_in_A_frame(4)
      fd_x_term_parameter_in_A_frame(1)
      fd_x_term_parameter_in_A_frame(2)
      fd_install_constraint_with_x_AF(4,3)
      fd_call_constraint
      execute(Pred_Name(X646F6D61696E,3),1,"domain",3)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Fd_Install(4)

      fd_create_C_frame(4,0,1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(4)

      fd_term_parameter(1,1)
      fd_term_parameter(0,2)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint



#define ASCII_PRED "indomain"
#define PRED       X696E646F6D61696E
#define ARITY      1

Begin_Public_Pred
      pragma_c(Indomain_1)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "labeling"
#define PRED       X6C6162656C696E67
#define ARITY      1

Begin_Public_Pred
      switch_on_term(G_label(1),G_label(2),fail,G_label(4),fail)

label(1)
      try_me_else(3)

label(2)
      get_nil(0)
      proceed

label(3)
      trust_me_else_fail

label(4)
      allocate(1)
      get_list(0)
      unify_x_variable(0)
      unify_y_variable(0)
      call(Pred_Name(X696E646F6D61696E,1),1,1,"indomain",1)          /* begin sub 1 */
      put_y_value(0,0)
      deallocate
      execute(Pred_Name(X6C6162656C696E67,1),1,"labeling",1)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "labelingff"
#define PRED       X6C6162656C696E676666
#define ARITY      1

Begin_Public_Pred
      pragma_c(Labelingff_1)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "labelingff1"
#define PRED       X6C6162656C696E67666631
#define ARITY      2

Begin_Private_Pred
      allocate(1)
      get_y_variable(0,0)
      put_x_value(1,0)
      call(Pred_Name(X696E646F6D61696E,1),1,1,"indomain",1)          /* begin sub 1 */
      put_y_value(0,0)
      deallocate
      execute(Pred_Name(X6C6162656C696E676666,1),1,"labelingff",1)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "deleteff"
#define PRED       X64656C6574656666
#define ARITY      3

Begin_Public_Pred
      get_list(1)
      unify_x_variable(4)
      unify_x_variable(1)
      get_x_variable(3,2)
      put_x_value(4,2)
      execute(Pred_Name(X64656C6574656666,4),1,"deleteff",4)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "deleteff"
#define PRED       X64656C6574656666
#define ARITY      4

Begin_Private_Pred
      allocate(5)
      get_y_variable(4,0)
      get_y_variable(3,1)
      get_y_variable(2,2)
      get_y_variable(0,3)
      put_y_value(2,0)
      put_y_variable(1,1)
      call(Pred_Name(X66645F73697A65,2),1,1,"fd_size",2)          /* begin sub 1 */
      put_y_value(4,0)
      put_y_value(3,1)
      put_y_value(2,2)
      put_y_unsafe_value(1,3)
      put_y_value(0,4)
      deallocate
      execute(Pred_Name(X64656C6574656666,5),1,"deleteff",5)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "deleteff"
#define PRED       X64656C6574656666
#define ARITY      5

Begin_Private_Pred
      try_me_else(1)
      get_x_value(0,2)
      get_integer(1,3)
      get_x_value(1,4)
      neck_cut
      proceed

label(1)
      retry_me_else(2)
      get_nil(1)
      get_x_value(0,2)
      get_nil(4)
      neck_cut
      proceed

label(2)
      trust_me_else_fail
      allocate(10)
      get_y_variable(4,0)
      get_list(1)
      unify_y_variable(9)
      unify_y_variable(3)
      get_y_variable(8,2)
      get_y_variable(7,3)
      get_y_variable(6,4)
      put_y_value(9,0)
      put_y_variable(5,1)
      call(Pred_Name(X66645F73697A65,2),1,1,"fd_size",2)          /* begin sub 1 */
      put_y_value(9,0)
      put_y_value(8,1)
      put_y_value(7,2)
      put_y_value(6,3)
      put_y_value(5,4)
      put_y_variable(2,5)
      put_y_variable(1,6)
      put_y_variable(0,7)
      call(Pred_Name(X64656C65746566665F2461757831,8),1,2,"deleteff_$aux1",8)          /* begin sub 2 */
      put_y_value(4,0)
      put_y_value(3,1)
      put_y_unsafe_value(2,2)
      put_y_unsafe_value(1,3)
      put_y_unsafe_value(0,4)
      deallocate
      execute(Pred_Name(X64656C6574656666,5),1,"deleteff",5)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "deleteff_$aux1"
#define PRED       X64656C65746566665F2461757831
#define ARITY      8

Begin_Private_Pred
      try_me_else(1)
      math_load_x_value(2,2)
      math_load_x_value(4,4)
      builtin_2(lte,2,4)
      neck_cut
      get_list(3)
      unify_x_local_value(0)
      unify_x_local_value(7)
      get_x_value(1,5)
      get_x_value(2,6)
      proceed

label(1)
      trust_me_else_fail
      get_list(3)
      unify_x_local_value(1)
      unify_x_local_value(7)
      get_x_value(0,5)
      get_x_value(4,6)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "alldifferent"
#define PRED       X616C6C646966666572656E74
#define ARITY      1

Begin_Public_Pred
      switch_on_term(G_label(1),G_label(2),fail,G_label(4),fail)

label(1)
      try_me_else(3)

label(2)
      get_nil(0)
      proceed

label(3)
      trust_me_else_fail

label(4)
      allocate(1)
      get_list(0)
      unify_x_variable(1)
      unify_y_variable(0)
      put_y_value(0,0)
      call(Pred_Name(X6F75745F6F66,2),1,1,"out_of",2)          /* begin sub 1 */
      put_y_value(0,0)
      deallocate
      execute(Pred_Name(X616C6C646966666572656E74,1),1,"alldifferent",1)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "out_of"
#define PRED       X6F75745F6F66
#define ARITY      2

Begin_Private_Pred
      switch_on_term(G_label(1),G_label(2),fail,G_label(4),fail)

label(1)
      try_me_else(3)

label(2)
      get_nil(0)
      proceed

label(3)
      trust_me_else_fail

label(4)
      allocate(2)
      get_list(0)
      unify_x_variable(2)
      unify_y_variable(1)
      get_y_variable(0,1)
      put_y_value(0,0)
      put_x_value(2,1)
      call(Pred_Name(X783C3E79,2),0,1,"x<>y",2)          /* begin sub 1 */
      put_y_value(1,0)
      put_y_value(0,1)
      deallocate
      execute(Pred_Name(X6F75745F6F66,2),1,"out_of",2)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "element"
#define PRED       X656C656D656E74
#define ARITY      3

Begin_Public_Pred
      allocate(4)
      get_y_variable(3,0)
      get_y_variable(0,1)
      get_y_variable(2,2)
      put_y_value(0,0)
      put_y_variable(1,1)
      call(Pred_Name(X6C656E677468,2),0,1,"length",2)          /* begin sub 1 */
      put_y_value(3,0)
      put_y_value(2,1)
      put_y_unsafe_value(1,2)
      put_y_value(0,3)
      deallocate
      execute(Pred_Name(X656C656D656E7431,4),1,"element1",4)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "element1"
#define PRED       X656C656D656E7431
#define ARITY      4

Begin_Private_Pred
      pragma_c(Element1_4)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "atmost"
#define PRED       X61746D6F7374
#define ARITY      3

Begin_Public_Pred
      allocate(4)
      get_y_variable(3,0)
      get_y_variable(0,1)
      get_y_variable(2,2)
      put_y_value(0,0)
      put_y_variable(1,1)
      call(Pred_Name(X6C656E677468,2),0,1,"length",2)          /* begin sub 1 */
      put_y_value(3,0)
      put_y_value(2,1)
      put_y_unsafe_value(1,2)
      put_y_value(0,3)
      deallocate
      execute(Pred_Name(X61746D6F737431,4),1,"atmost1",4)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "atmost1"
#define PRED       X61746D6F737431
#define ARITY      4

Begin_Private_Pred
      pragma_c(Atmost1_4)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "relation"
#define PRED       X72656C6174696F6E
#define ARITY      2

Begin_Public_Pred
      allocate(2)
      get_y_variable(0,1)
      put_y_variable(1,1)
      call(Pred_Name(X6C696E65735F746F5F636F6C756D6E73,2),1,1,"lines_to_columns",2)          /* begin sub 1 */
      put_y_unsafe_value(1,0)
      put_y_value(0,1)
      put_x_variable(2,2)
      deallocate
      execute(Pred_Name(X72656C6174696F6E6331,3),1,"relationc1",3)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "relationc"
#define PRED       X72656C6174696F6E63
#define ARITY      2

Begin_Public_Pred
      put_x_variable(2,2)
      execute(Pred_Name(X72656C6174696F6E6331,3),1,"relationc1",3)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "relationc1"
#define PRED       X72656C6174696F6E6331
#define ARITY      3

Begin_Private_Pred
      switch_on_term(G_label(1),G_label(2),fail,G_label(4),fail)

label(1)
      try_me_else(3)

label(2)
      get_nil(0)
      get_nil(1)
      proceed

label(3)
      trust_me_else_fail

label(4)
      allocate(3)
      get_list(0)
      unify_x_variable(4)
      unify_y_variable(2)
      get_list(1)
      unify_x_variable(3)
      unify_y_variable(1)
      get_y_variable(0,2)
      put_y_value(0,0)
      put_x_value(4,1)
      put_x_value(3,2)
      call(Pred_Name(X656C656D656E74,3),1,1,"element",3)          /* begin sub 1 */
      put_y_value(2,0)
      put_y_value(1,1)
      put_y_value(0,2)
      deallocate
      execute(Pred_Name(X72656C6174696F6E6331,3),1,"relationc1",3)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "lines_to_columns"
#define PRED       X6C696E65735F746F5F636F6C756D6E73
#define ARITY      2

Begin_Private_Pred
      try_me_else(2)
      switch_on_term(G_label(1),fail,fail,G_label(1),fail)

label(1)
      get_list(0)
      unify_nil
      unify_void(1)
      get_nil(1)
      neck_cut
      proceed

label(2)
      trust_me_else_fail
      allocate(2)
      get_list(1)
      unify_x_variable(1)
      unify_y_variable(0)
      put_y_variable(1,2)
      call(Pred_Name(X6372656174655F636F6C756D6E,3),1,1,"create_column",3)          /* begin sub 1 */
      put_y_unsafe_value(1,0)
      put_y_value(0,1)
      deallocate
      execute(Pred_Name(X6C696E65735F746F5F636F6C756D6E73,2),1,"lines_to_columns",2)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "create_column"
#define PRED       X6372656174655F636F6C756D6E
#define ARITY      3

Begin_Private_Pred
      switch_on_term(G_label(1),G_label(2),fail,G_label(4),fail)

label(1)
      try_me_else(3)

label(2)
      get_nil(0)
      get_nil(1)
      get_nil(2)
      proceed

label(3)
      trust_me_else_fail

label(4)
      get_list(0)
      unify_x_variable(3)
      unify_x_variable(0)
      get_list(3)
      unify_x_variable(4)
      unify_x_variable(3)
      get_list(1)
      unify_x_value(4)
      unify_x_variable(1)
      get_list(2)
      unify_x_value(3)
      unify_x_variable(2)
      execute(Pred_Name(X6372656174655F636F6C756D6E,3),1,"create_column",3)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "minof"
#define PRED       X6D696E6F66
#define ARITY      2

Begin_Public_Pred
      allocate(4)
      get_y_variable(2,0)
      get_y_variable(1,1)
      get_y_bc_reg(0)
      put_y_variable(3,0)
      call(Pred_Name(X66645F696E66696E697479,1),1,1,"fd_infinity",1)          /* begin sub 1 */
      put_constant(X246375725F6D696E,1,"$cur_min")
      put_y_unsafe_value(3,0)
      builtin_2(g_assign,1,0)
      call(Pred_Name(X726570656174,0),0,2,"repeat",0)          /* begin sub 2 */
      put_constant(X246375725F6D696E,1,"$cur_min")
      put_x_variable(3,0)
      builtin_2(g_read,1,0)
      put_y_value(2,0)
      put_y_value(1,1)
      put_y_unsafe_value(0,2)
      deallocate
      execute(Pred_Name(X6D696E6F665F2461757832,4),1,"minof_$aux2",4)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "minof_$aux2"
#define PRED       X6D696E6F665F2461757832
#define ARITY      4

Begin_Private_Pred
      try_me_else(1)
      allocate(3)
      get_y_variable(1,1)
      get_y_bc_reg(2)
      fd_set_x_AF(2,1)
      fd_y_value_in_A_frame(1)
      fd_x_term_parameter_in_A_frame(3)
      fd_install_constraint_with_x_AF(5,1)
      fd_call_constraint
      call(Pred_Name(X63616C6C,1),0,1,"call",1)          /* begin sub 1 */
      cut_y(2)
      put_y_value(1,0)
      put_y_variable(0,1)
      call(Pred_Name(X66645F6D696E,2),1,2,"fd_min",2)          /* begin sub 2 */
      put_constant(X246375725F6D696E,1,"$cur_min")
      put_y_unsafe_value(0,0)
      builtin_2(g_assign,1,0)
      fail

label(1)
      trust_me_else_fail
      cut_x(2)
      get_x_value(3,1)
      execute(Pred_Name(X63616C6C,1),0,"call",1)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Fd_Install(5)

      fd_create_C_frame(5,0,1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(5)

      fd_integer(1,0)
      fd_term_parameter(0,1)
      fd_integer(2,1)
      fd_term_sub_term(0,2)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint



#define ASCII_PRED "maxof"
#define PRED       X6D61786F66
#define ARITY      2

Begin_Public_Pred
      allocate(3)
      get_y_variable(2,0)
      get_y_variable(1,1)
      get_y_bc_reg(0)
      put_constant(X246375725F6D6178,1,"$cur_max")
      put_integer(0,0)
      builtin_2(g_assign,1,0)
      call(Pred_Name(X726570656174,0),0,1,"repeat",0)          /* begin sub 1 */
      put_constant(X246375725F6D6178,1,"$cur_max")
      put_x_variable(3,0)
      builtin_2(g_read,1,0)
      put_y_value(2,0)
      put_y_value(1,1)
      put_y_unsafe_value(0,2)
      deallocate
      execute(Pred_Name(X6D61786F665F2461757833,4),1,"maxof_$aux3",4)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "maxof_$aux3"
#define PRED       X6D61786F665F2461757833
#define ARITY      4

Begin_Private_Pred
      try_me_else(1)
      allocate(3)
      get_y_variable(1,1)
      get_y_bc_reg(2)
      fd_set_x_AF(2,1)
      fd_y_value_in_A_frame(1)
      fd_x_term_parameter_in_A_frame(3)
      fd_install_constraint_with_x_AF(6,1)
      fd_call_constraint
      call(Pred_Name(X63616C6C,1),0,1,"call",1)          /* begin sub 1 */
      cut_y(2)
      put_y_value(1,0)
      put_y_variable(0,1)
      call(Pred_Name(X66645F6D6178,2),1,2,"fd_max",2)          /* begin sub 2 */
      put_constant(X246375725F6D6178,1,"$cur_max")
      put_y_unsafe_value(0,0)
      builtin_2(g_assign,1,0)
      fail

label(1)
      trust_me_else_fail
      cut_x(2)
      get_x_value(3,1)
      execute(Pred_Name(X63616C6C,1),0,"call",1)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Fd_Install(6)

      fd_create_C_frame(6,0,1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(6)

      fd_term_parameter(1,1)
      fd_integer(0,1)
      fd_term_add_term(1,0)
      fd_integer(0,infinity)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint



#define ASCII_PRED "$exe_1"
#define PRED       X246578655F31
#define ARITY      0

Begin_Private_Pred
      allocate(1)
      get_y_bc_reg(0)
      call(Pred_Name(X246578655F315F2461757834,0),1,1,"$exe_1_$aux4",0)          /* begin sub 1 */
      cut_y(0)
      deallocate
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "$exe_1_$aux4"
#define PRED       X246578655F315F2461757834
#define ARITY      0

Begin_Private_Pred
      try_me_else(1)
      allocate(0)
      put_integer(700,0)
      put_constant(X786678,1,"xfx")
      put_constant(X696E,2,"in")
      call(Pred_Name(X6F70,3),0,1,"op",3)          /* begin sub 1 */
      put_integer(690,0)
      put_constant(X7866,1,"xf")
      put_constant(X6E6F5F6F707432,2,"no_opt2")
      call(Pred_Name(X6F70,3),0,2,"op",3)          /* begin sub 2 */
      put_integer(650,0)
      put_constant(X796678,1,"yfx")
      put_constant(X3A,2,":")
      call(Pred_Name(X6F70,3),0,3,"op",3)          /* begin sub 3 */
      put_integer(600,0)
      put_constant(X796678,1,"yfx")
      put_constant(X26,2,"&")
      call(Pred_Name(X6F70,3),0,4,"op",3)          /* begin sub 4 */
      put_integer(550,0)
      put_constant(X786678,1,"xfx")
      put_constant(X2E2E,2,"..")
      call(Pred_Name(X6F70,3),0,5,"op",3)          /* begin sub 5 */
      put_integer(400,0)
      put_constant(X796678,1,"yfx")
      put_list(3)
      unify_constant(X2F3E,"/>")
      unify_nil
      put_list(2)
      unify_constant(X2F3C,"/<")
      unify_x_value(3)
      call(Pred_Name(X6F70,3),0,6,"op",3)          /* begin sub 6 */
      put_integer(700,0)
      put_constant(X786678,1,"xfx")
      put_list(3)
      unify_constant(X233E3D,"#>=")
      unify_nil
      put_list(2)
      unify_constant(X233E,"#>")
      unify_x_value(3)
      put_list(3)
      unify_constant(X233C3D,"#<=")
      unify_x_value(2)
      put_list(2)
      unify_constant(X233C,"#<")
      unify_x_value(3)
      put_list(3)
      unify_constant(X235C3D,"#\\=")
      unify_x_value(2)
      put_list(2)
      unify_constant(X233D,"#=")
      unify_x_value(3)
      call(Pred_Name(X6F70,3),0,7,"op",3)          /* begin sub 7 */
      fail

label(1)
      trust_me_else_fail
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Init_Tables(fd_bips)

 Define_Atom(X5B5D,"[]")
 Define_Atom(X66645F766563746F725F6D6178,"fd_vector_max")
 Define_Atom(X66645F696E66696E697479,"fd_infinity")
 Define_Atom(X66645F766172,"fd_var")
 Define_Atom(X66645F6D696E,"fd_min")
 Define_Atom(X66645F6D6178,"fd_max")
 Define_Atom(X66645F646F6D,"fd_dom")
 Define_Atom(X66645F73697A65,"fd_size")
 Define_Atom(X66645F65787472615F63737472,"fd_extra_cstr")
 Define_Atom(X66645F6861735F766563746F72,"fd_has_vector")
 Define_Atom(X66645F7573655F766563746F72,"fd_use_vector")
 Define_Atom(X66645F756E696679,"fd_unify")
 Define_Atom(X646F6D61696E,"domain")
 Define_Atom(X696E646F6D61696E,"indomain")
 Define_Atom(X6C6162656C696E67,"labeling")
 Define_Atom(X6C6162656C696E676666,"labelingff")
 Define_Atom(X6C6162656C696E67666631,"labelingff1")
 Define_Atom(X64656C6574656666,"deleteff")
 Define_Atom(X64656C65746566665F2461757831,"deleteff_$aux1")
 Define_Atom(X616C6C646966666572656E74,"alldifferent")
 Define_Atom(X6F75745F6F66,"out_of")
 Define_Atom(X656C656D656E74,"element")
 Define_Atom(X656C656D656E7431,"element1")
 Define_Atom(X61746D6F7374,"atmost")
 Define_Atom(X61746D6F737431,"atmost1")
 Define_Atom(X72656C6174696F6E,"relation")
 Define_Atom(X72656C6174696F6E63,"relationc")
 Define_Atom(X72656C6174696F6E6331,"relationc1")
 Define_Atom(X6C696E65735F746F5F636F6C756D6E73,"lines_to_columns")
 Define_Atom(X6372656174655F636F6C756D6E,"create_column")
 Define_Atom(X6D696E6F66,"minof")
 Define_Atom(X246375725F6D696E,"$cur_min")
 Define_Atom(X6D696E6F665F2461757832,"minof_$aux2")
 Define_Atom(X6D61786F66,"maxof")
 Define_Atom(X246375725F6D6178,"$cur_max")
 Define_Atom(X6D61786F665F2461757833,"maxof_$aux3")
 Define_Atom(X246578655F31,"$exe_1")
 Define_Atom(X246578655F315F2461757834,"$exe_1_$aux4")
 Define_Atom(X786678,"xfx")
 Define_Atom(X696E,"in")
 Define_Atom(X7866,"xf")
 Define_Atom(X6E6F5F6F707432,"no_opt2")
 Define_Atom(X796678,"yfx")
 Define_Atom(X3A,":")
 Define_Atom(X26,"&")
 Define_Atom(X2E2E,"..")
 Define_Atom(X2F3E,"/>")
 Define_Atom(X2F3C,"/<")
 Define_Atom(X233E3D,"#>=")
 Define_Atom(X233E,"#>")
 Define_Atom(X233C3D,"#<=")
 Define_Atom(X233C,"#<")
 Define_Atom(X235C3D,"#\\=")
 Define_Atom(X233D,"#=")


 Define_Pred(X66645F766563746F725F6D6178,1,1)

 Define_Pred(X66645F696E66696E697479,1,1)

 Define_Pred(X66645F766172,1,1)

 Define_Pred(X66645F6D696E,2,1)

 Define_Pred(X66645F6D6178,2,1)

 Define_Pred(X66645F646F6D,2,1)

 Define_Pred(X66645F73697A65,2,1)

 Define_Pred(X66645F65787472615F63737472,2,1)

 Define_Pred(X66645F6861735F766563746F72,1,1)

 Define_Pred(X66645F7573655F766563746F72,1,1)

 Define_Pred(X66645F756E696679,2,1)

 Define_Pred(X646F6D61696E,3,1)

 Define_Pred(X696E646F6D61696E,1,1)

 Define_Pred(X6C6162656C696E67,1,1)

 Define_Pred(X6C6162656C696E676666,1,1)

 Define_Pred(X6C6162656C696E67666631,2,0)

 Define_Pred(X64656C6574656666,3,1)

 Define_Pred(X64656C6574656666,4,0)

 Define_Pred(X64656C6574656666,5,0)

 Define_Pred(X64656C65746566665F2461757831,8,0)

 Define_Pred(X616C6C646966666572656E74,1,1)

 Define_Pred(X6F75745F6F66,2,0)

 Define_Pred(X656C656D656E74,3,1)

 Define_Pred(X656C656D656E7431,4,0)

 Define_Pred(X61746D6F7374,3,1)

 Define_Pred(X61746D6F737431,4,0)

 Define_Pred(X72656C6174696F6E,2,1)

 Define_Pred(X72656C6174696F6E63,2,1)

 Define_Pred(X72656C6174696F6E6331,3,0)

 Define_Pred(X6C696E65735F746F5F636F6C756D6E73,2,0)

 Define_Pred(X6372656174655F636F6C756D6E,3,0)

 Define_Pred(X6D696E6F66,2,1)

 Define_Pred(X6D696E6F665F2461757832,4,0)

 Define_Pred(X6D61786F66,2,1)

 Define_Pred(X6D61786F665F2461757833,4,0)

 Define_Pred(X246578655F31,0,0)

 Define_Pred(X246578655F315F2461757834,0,0)

 Init_Usr_File

End_Init_Tables


Begin_Exec_Directives(fd_bips)


 Exec_Directive(1,Pred_Name(X246578655F31,0))

End_Exec_Directives
